/*
 * Copyright (c) 2004, 2005, 2006
 *      Luiz Souza <loos.br@gmail.com>.  All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR THE VOICES IN HIS HEAD
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <sys/types.h>
#include <sys/time.h>

#include <errno.h>
#include <string.h>
#include <unistd.h>

int io_read(fd, buf, len)
register int fd;
register char *buf;
register int len;
{
 register int r;

    for(;;) {
	r = read(fd, buf, len);
	if(r == -1) if(errno == EINTR) continue;
	return r;
    }
}

int io_write(fd, buf, len)
register int fd;
register char *buf;
register int len;
{
 register int w;

    while(len) {
	w = write(fd, buf, len);
	if (w == -1) { if (errno == EINTR) continue; return(-1); }
	if (w == 0) ; /* luser's fault */
	buf += w;
	len -= w;
    }
    return(0);
}

