/*
 * Copyright (c) 2004, 2005, 2006
 *      Luiz Souza <loos.br@gmail.com>.  All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR THE VOICES IN HIS HEAD
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * $Id: string.h,v 1.2.2.1 2006/08/01 21:08:38 luiz Exp $
 */

#ifndef STRING_H
#define STRING_H

#include <stdlib.h>

#define	STRING_MIN_LEN		64

#ifndef __INT_MAX
#define __INT_MAX	0x7fff
#endif

typedef struct {
    unsigned char	*s;
    unsigned char	*p;
    __int32_t		a;
    __int32_t		len;
} string;

typedef struct {
    string		**string;
    __uint32_t 		len;
} strings;

unsigned char 		*_strchr(register unsigned char *s, int c);
__int32_t		str_cat(string *s, register char *p, __uint32_t len);
__int32_t		str_len(string *s);
__int32_t		str_cats(string *s, register char *p);
__int32_t		str_copy(string *s, register char *p, __uint32_t len);
__int32_t		str_copys(string *s, register char *p);
__int32_t		str_ready(string *s, __int32_t size);
__int32_t		str_get_size(__uint32_t len);
string			*str_alloc(void);
void			str_free(string *s);
void			str_zero(string *s);
void			str_reset(string *s);
void			str_strip(string *s);
int			str_cmp(string *str1, string *str2);
int			str_casecmp(string *str1, string *str2);
int			str_ncmp(string *str1, string *str2, __uint32_t n);
int			str_ncasecmp(string *str1, string *str2, __uint32_t n);

#endif
